/**
* UnaryNode.h - A node with a single neighbour
* 
**/
#ifndef UnaryNode_h
#define UnaryNode_h

template <class O>
class UnaryNode{

  public:
 
    /**
    * Constructor: Create a new UnaryNode with a given element
    * @param data - The element to be contained within the UnaryNode
    * @post this->data == data && this->next == NULL
    **/
    UnaryNode( const O& data );
  
    /**
    * Constructor: Create a new UnaryNode with a given element
    * @param data - The element to be contained within the UnaryNode
    * @param next - Neighbour of this UnaryNode.
    * @post this->data == data && this->next == next
    **/
    UnaryNode( const O& data, UnaryNode<O>* next);

    O data;              /** Data element of UnaryNode */
    UnaryNode<O>* next;  /** Neighbour of this UnaryNode */
};

template <class O>
UnaryNode<O>::UnaryNode(const O& data) : data(data), next(NULL){
}

template <class O>
UnaryNode<O>::UnaryNode(const O& data, UnaryNode<O>* next) : data(data), next(next){
}

#endif
